# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getActionparameterTables(meta):
    actionparameter1 = Table('actionparameter1', meta, autoload=True)
    actionparameter2 = Table('actionparameter2', meta, autoload=True)
    return [actionparameter1, actionparameter2]

class Dictionaries(object):
    def __init__(self, meta):
        self.macro=Table('macro',meta,
            Column('macrocode',Integer,nullable=False,primary_key=True),
            Column('macroname',String(255),nullable=True)
        )

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            table.create()
    conn = migrate_engine.connect()
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('create view %s as select * from %s' % (basename, basename + '1'))

    for tbl in getActionparameterTables(meta):
        parametername = Column('parametername', String(255), nullable=True)
        parametername.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'actionparameter')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    tblname = views_helper.get_table_name(migrate_engine,'actionparameter')
    dictionaries = Dictionaries(meta)
    for table in filter(lambda x: isinstance(x,Table), map(lambda x: getattr(dictionaries,x), dir(dictionaries))):
        basename = table.name
        for suffix in ['1','2']:
            table.name = basename+suffix
            table.drop()
    conn = migrate_engine.connect()
    for table in filter(lambda x: isinstance(x, Table), map(lambda x: getattr(dictionaries, x), dir(dictionaries))):
        basename = table.name[:-1]
        conn.execute('drop view %s' % (basename))
    
    for tbl in getActionparameterTables(meta):
        tbl.c.parametername.drop()
    views_helper.update_dic_view(migrate_engine, 'actionparameter',tblname)
