from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getDeptTables(meta):
    dept1 = Table('dept1', meta, autoload=True)
    dept2 = Table('dept2', meta, autoload=True)
    return [dept1, dept2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for tbl in getDeptTables(meta):
        idclient = Column('idclient', Integer, nullable=True)
        idclient.create(tbl)
        idclient = Column('documentprefix', String(20), nullable=True)
        idclient.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'dept')


def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    tblname = views_helper.get_table_name(migrate_engine,'dept')
    for tbl in getDeptTables(meta):
        if 'documentprefix' in tbl.c:
            tbl.c.documentprefix.drop()
        tbl.c.idclient.drop()
    views_helper.update_dic_view(migrate_engine, 'dept',tblname)
