from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getCardTables(meta):
    card1 = Table('card1', meta, autoload=True)
    card2 = Table('card2', meta, autoload=True)
    return [card1, card2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for tbl in getCardTables(meta):
        blocked = Column('blocked', Integer, nullable=True, default=0)
        blocked.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'card')


def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    tblname = views_helper.get_table_name(migrate_engine,'card')
    for tbl in getCardTables(meta):
        tbl.c.blocked.drop()
    views_helper.update_dic_view(migrate_engine, 'card',tblname)
