from sqlalchemy import *
from migrate import *
import migrate.changeset
try:
    from sqlalchemy.dialects.mysql.base import MSMediumText
except:
    from sqlalchemy.databases.mysql import MSMediumText
from dictionaries.versions import views_helper

def getDiscountsystemTables(meta):
    discountsystem1 = Table('discountsystem1', meta, autoload=True)
    discountsystem2 = Table('discountsystem2', meta, autoload=True)
    return [discountsystem1, discountsystem2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for disc in getDiscountsystemTables(meta): 
        disc.c.discsystem.alter(type = MSMediumText())
        disc.c.bonusearnsystem.alter(type = MSMediumText())
        disc.c.bonuslimitsystem.alter(type = MSMediumText())
    views_helper.update_dic_view(migrate_engine, 'discountsystem')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    for disc in getDiscountsystemTables(meta): 
        disc.c.discsystem.alter(type = Text())
        disc.c.bonusearnsystem.alter(type = Text())
        disc.c.bonuslimitsystem.alter(type = Text())
    views_helper.update_dic_view(migrate_engine, 'discountsystem')
