from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getKitTable(meta):
    kit1 = Table('kit1', meta, autoload=True)
    kit2 = Table('kit2', meta, autoload=True)
    return [kit1, kit2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    for tbl in getKitTable(meta):
        if not 'maxtimes' in tbl.columns:
            Column('maxtimes', Integer, nullable=True).create(tbl)        
    views_helper.update_dic_view(migrate_engine, 'kit')    

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    tblname = views_helper.get_table_name(migrate_engine,'kit')
    for tbl in getKitTable(meta):
        if 'maxtimes' in tbl.columns:
            tbl.c.maxtimes.drop()    
    views_helper.update_dic_view(migrate_engine, 'kit',tblname)
