from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getTable(meta):
    return Table('certificate', meta,
        Column('code', Integer, nullable = False, primary_key = True),
        Column('rangefrom', Integer, nullable = False),
        Column('rangeto', Integer, nullable = False),
        Column('name', String(100), nullable = True),
        Column('sum', Numeric(precision = 20, scale = 2), nullable = True),
        Column('inputmask', Integer, nullable = False)
    )

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    views_helper.create_table(migrate_engine, getTable(meta))

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    views_helper.drop_table(migrate_engine, getTable(meta))
