from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

tableName = 'tprices'

oldKey = ('bcode', 'tindex')
oldKeyInnoDB = ('tindex', 'bcode')

newKey = ('bcode', 'tindex', 'effectivedate')
newKeyInnoDB = ('tindex', 'bcode', 'effectivedate')

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    for table in views_helper.getTables(meta, tableName):
        table.c.tindex.alter(autoincrement=False)
        pk = constraint.PrimaryKeyConstraint(*(oldKey if not views_helper.isInnoDB(migrate_engine, table.name) else oldKeyInnoDB), table=table)
        pk.drop()
        table.c.effectivedate.alter(primary_key=True)
        pk = constraint.PrimaryKeyConstraint(*(newKey if not views_helper.isInnoDB(migrate_engine, table.name) else newKeyInnoDB), table=table)
        pk.create()

        table.c.documentid.alter(nullable=True)
        table.c.tindex.alter(autoincrement=True)
    views_helper.update_dic_view(migrate_engine, tableName)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    for table in views_helper.getTables(meta, tableName):
        table.c.tindex.alter(autoincrement=False)

        pk = constraint.PrimaryKeyConstraint(*(newKey if not views_helper.isInnoDB(migrate_engine, table.name) else newKeyInnoDB), table=table)
        pk.drop()
        table.c.effectivedate.alter(primary_key=False)
        pk = constraint.PrimaryKeyConstraint(*(oldKey if not views_helper.isInnoDB(migrate_engine, table.name) else oldKeyInnoDB), table=table)
        pk.create()

        table.c.documentid.alter(nullable=False)
        table.c.tindex.alter(autoincrement=True)
    views_helper.update_dic_view(migrate_engine, tableName)

