# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    
    conn = migrate_engine.connect()
 
    conn.execute("""ALTER VIEW `shmdiscounts` AS 
	SELECT
	  `ws`.`cashcode` AS `cashcode`,
	  `ws`.`shiftnum` AS `shift`,
	  `dc`.`checknum` AS `checknum`,
	  IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,
	  (`di`.`discnumber` * 2) AS `dnum`,
	  `di`.`dtime`    AS `dtime`,
	  IF((`di`.`ispositiondiscount` = 1),`gi`.`deptcode`,0) AS `dcode`,
	  `di`.`scode`    AS `scode`,
	  ((IF((`di`.`disctype` = 1),17,15) + IF((`di`.`ispositiondiscount` = 1),0,20)) + IF((SUM(`di`.`discsum`) < 0),1,0)) AS `opcode`,
	  IF((`di`.`ispositiondiscount` = 1),`gi`.`code`,0) AS `code`,
	  IF((`di`.`disctype` = 3),ABS(SUM(`di`.`discsum`)),MAX(`di`.`discsize`)) AS `dsize`,
	  (ABS(SUM(`di`.`discsum`)) * IF((`dc`.`doctype` = 1),1,-(1))) AS `dsum`
	FROM (((`discitem` `di`
	     JOIN `workshift` `ws`)
	     JOIN `document` `dc`)
	     JOIN `goodsitem` `gi`)
	WHERE ((`ws`.`workshiftid` = `dc`.`workshiftid`)
	       AND (`dc`.`documentid` = `gi`.`documentid`)
	       AND (`gi`.`goodsitemid` = `di`.`goodsitemid`)
	       AND (`dc`.`closed` = 1))
	GROUP BY 1,2,3,4,5,6,7,8,10 """)
    conn.execute("""ALTER VIEW `shmdiscountsdetail` AS 
	SELECT
	  `ws`.`cashcode` AS `cashcode`,
	  `ws`.`shiftnum` AS `shift`,
	  `dc`.`checknum` AS `checknum`,
	  IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,
	  ((`di`.`discnumber` * 2) + 1) AS `dnum`,
	  `di`.`dtime`    AS `dtime`,
	  `di`.`scode`    AS `scode`,
	  IF((`di`.`ispositiondiscount` = 1),70,71) AS `opcode`,
	  (ABS(SUM(`di`.`discsum`)) * IF((`dc`.`doctype` = 1),1,-(1))) AS `dsum`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` WHEN 2 THEN `di`.`cardnumber` WHEN 5 THEN `di`.`discscheme` ELSE 0 END) AS `dprm1`,
	  (CASE `di`.`discmode` WHEN 1 THEN 2 WHEN 2 THEN 3 WHEN 3 THEN 1 WHEN 5 THEN 2 ELSE 0 END) AS `dtype`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` WHEN 2 THEN ABS(`dc`.`sumb`) WHEN 5 THEN `di`.`disccode` ELSE 0 END) AS `dprm2`,
	  IF((`di`.`ispositiondiscount` = 1),IF((`di`.`checksum` = 0),0,ABS(((SUM(`di`.`discsum`) / `di`.`checksum`) * 100))),IF((`dc`.`sumb` = 0),0,ABS(((SUM(`di`.`discsum`) / `dc`.`sumb`) * 100)))) AS `dprm3`
	FROM (((`discitem` `di`
	     JOIN `workshift` `ws`)
	    JOIN `document` `dc`)
	   JOIN `goodsitem` `gi`)
	WHERE ((`ws`.`workshiftid` = `dc`.`workshiftid`)
	       AND (`dc`.`documentid` = `gi`.`documentid`)
	       AND (`gi`.`goodsitemid` = `di`.`goodsitemid`)
	       AND (`dc`.`closed` = 1))
	GROUP BY 1,2,3,4,5,6,7,8,10,11,12 """)
    conn.execute("""ALTER VIEW `shmdiscountsdetailext` AS 
	SELECT
	  `ws`.`cashcode`    AS `cashcode`,
	  `ws`.`shiftnum`    AS `shift`,
	  `dc`.`checknum`    AS `checknum`,
	  `di`.`positionnum` AS `posnum`,
	  ((`di`.`discnumber` * 2) + 1) AS `dnum`,
	  `di`.`dtime`       AS `dtime`,
	  `di`.`scode`       AS `scode`,
	  70                 AS `opcode`,
	  IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` WHEN 2 THEN `di`.`cardnumber` WHEN 5 THEN `di`.`discscheme` ELSE 0 END) AS `dprm1`,
	  (CASE `di`.`discmode` WHEN 1 THEN 2 WHEN 2 THEN 3 WHEN 3 THEN 1 WHEN 5 THEN 2 ELSE 0 END) AS `dtype`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` WHEN 2 THEN ABS(`dc`.`sumb`) WHEN 5 THEN `di`.`disccode` ELSE 0 END) AS `dprm2`,
	  ABS(((`di`.`discsum` / IF((`di`.`checksum` = 0),1,`di`.`checksum`)) * 100)) AS `dprm3`
	FROM (((`discitem` `di`
	     JOIN `workshift` `ws`)
	    JOIN `document` `dc`)
	   JOIN `goodsitem` `gi`)
	WHERE ((`ws`.`workshiftid` = `dc`.`workshiftid`)
	       AND (`dc`.`documentid` = `gi`.`documentid`)
	       AND (`gi`.`goodsitemid` = `di`.`goodsitemid`)
	       AND (`dc`.`closed` = 1)) """)
    conn.execute("""ALTER VIEW `shmdiscountsext` AS 
	SELECT
	  `ws`.`cashcode`    AS `cashcode`,
	  `ws`.`shiftnum`    AS `shift`,
	  `dc`.`checknum`    AS `checknum`,
	  `di`.`positionnum` AS `posnum`,
	  (`di`.`discnumber` * 2) AS `dnum`,
	  `di`.`dtime`       AS `dtime`,
	  COALESCE(`gi`.`deptcode`,0) AS `dcode`,
	  `di`.`scode`       AS `scode`,
	  (IF((`di`.`disctype` = 1),17,15) + IF((`di`.`discsum` < 0),1,0)) AS `opcode`,
	  COALESCE(`gi`.`code`,0) AS `code`,
	  IF((`di`.`disctype` = 3),ABS(`di`.`discsum`),ABS(`di`.`discsize`)) AS `dsize`,
	  IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum`
	FROM (((`discitem` `di`
	     JOIN `workshift` `ws`)
	    JOIN `document` `dc`)
	   JOIN `goodsitem` `gi`)
	WHERE ((`ws`.`workshiftid` = `dc`.`workshiftid`)
	       AND (`dc`.`documentid` = `gi`.`documentid`)
	       AND (`gi`.`goodsitemid` = `di`.`goodsitemid`)
	       AND (`dc`.`closed` = 1)) """)

def downgrade(migrate_engine):                                                                              
    # Operations to reverse the above upgrade go here.
    conn = migrate_engine.connect()
    conn.execute("""ALTER VIEW `shmdiscounts` AS 
	SELECT   
	`ws`.`cashcode` AS `cashcode`, 
	`ws`.`shiftnum` AS `shift`, 
	`dc`.`checknum` AS `checknum`, 
	IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,  
	(`di`.`discnumber` * 2) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	COALESCE(`gi`.`deptcode`,0) AS `dcode`,  
	`di`.`scode` AS `scode`,  
	((IF((`di`.`disctype` = 1),17,15) + IF((`di`.`ispositiondiscount` = 1),0,20)) + IF((`di`.`discsum` < 0),1,0)) AS `opcode`,  
	COALESCE(`gi`.`code`,0) AS `code`,  
	IF((`di`.`disctype` = 3),ABS(`di`.`discsum`),ABS((`di`.`discsize`))) AS `dsize`,  
	IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` and `dc`.`closed` = 1 """)
    conn.execute("""ALTER  VIEW `shmdiscountsext` AS 
	SELECT  
	`ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`,  
	`dc`.`checknum` AS `checknum`,  
	`di`.`positionnum` AS `posnum`, 
	(`di`.`discnumber` * 2) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	COALESCE(`gi`.`deptcode`,0) AS `dcode`,  
	`di`.`scode` AS `scode` ,
	(IF((`di`.`disctype` = 1),17,15) + IF((`di`.`discsum` < 0),1,0)) AS `opcode`,  
	COALESCE(`gi`.`code`,0) AS `code`,  
	IF((`di`.`disctype` = 3),ABS(`di`.`discsum`),ABS((`di`.`discsize`))) AS `dsize`,
	IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` and `dc`.`closed` = 1 """)
    conn.execute(""" ALTER VIEW `shmdiscountsdetail` AS 
	SELECT   `ws`.`cashcode` AS `cashcode`,  
	`ws`.`shiftnum` AS `shift`, 
	`dc`.`checknum` AS `checknum`, 
	IF((`di`.`ispositiondiscount` = 1),`di`.`positionnum`,10000) AS `posnum`,  
	((`di`.`discnumber` * 2) + 1) AS `dnum`,  
	`di`.`dtime` AS `dtime`,  
	`di`.`scode` AS `scode`, 
	IF((`di`.`ispositiondiscount` = 1),70,71) AS `opcode`, 
	IF((`dc`.`doctype` = 1),ABS((`di`.`discsum`)),-(ABS((`di`.`discsum`)))) AS `dsum`,
	(CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` 
		 WHEN 2 THEN `di`.`cardnumber` 
		 WHEN 5 THEN `di`.`discscheme` 
		 ELSE 0 END) AS `dprm1`,  
	(CASE `di`.`discmode` WHEN 1 THEN 2 
		 WHEN 2 THEN 3 
		 WHEN 3 THEN 1 
		 WHEN 5 THEN 2 
		 ELSE 0 END) AS `dtype`,  
	(CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` 
		 WHEN 2 THEN ABS(`dc`.`sumb`) 
		 WHEN 5 THEN `di`.`disccode` 
		 ELSE 0 END) AS `dprm2`,  
	IF((`di`.`ispositiondiscount` = 1),IF((`di`.`checksum` = 0),0,ABS(((`di`.`discsum` / `di`.`checksum`) * 100))),IF((`dc`.`sumb` = 0),0,ABS(((`di`.`discsum` / `dc`.`sumb`) * 100)))) AS `dprm3` 
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` AND  `di`.`ispositiondiscount` = 1 and `dc`.`closed` = 1""")
    conn.execute(""" ALTER VIEW `shmdiscountsdetailext` AS 
	  SELECT
 	  `ws`.`cashcode`    AS `cashcode`,
	  `ws`.`shiftnum`    AS `shift`,
	  `dc`.`checknum`    AS `checknum`,
	  `di`.`positionnum` AS `posnum`,
	  ((`di`.`discnumber` * 2) + 1) AS `dnum`,
	  `di`.`dtime`       AS `dtime`,
	  `di`.`scode`       AS `scode`,
	  70                 AS `opcode`,
	  IF((`dc`.`doctype` = 1),ABS(`di`.`discsum`),-(ABS(`di`.`discsum`))) AS `dsum`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`discscheme` WHEN 2 THEN `di`.`cardnumber` WHEN 5 THEN `di`.`discscheme` ELSE 0 END) AS `dprm1`,
	  (CASE `di`.`discmode` WHEN 1 THEN 2 WHEN 2 THEN 3 WHEN 3 THEN 1 WHEN 5 THEN 2 ELSE 0 END) AS `dtype`,
	  (CASE `di`.`discmode` WHEN 1 THEN `di`.`disccode` WHEN 2 THEN ABS(`dc`.`sumb`) WHEN 5 THEN `di`.`disccode` ELSE 0 END) AS `dprm2`,
	  ABS(((`di`.`discsum` / IF((`di`.`checksum` = 0),1,`di`.`checksum`)) * 100)) AS `dprm3`
	FROM `discitem` `di`,`workshift` `ws`,`document` `dc`,`goodsitem` `gi`
	WHERE `ws`.`workshiftid` = `dc`.`workshiftid` AND `dc`.`documentid` = `gi`.`documentid`
	AND `gi`.`goodsitemid` = `di`.`goodsitemid` AND  `di`.`ispositiondiscount` = 1 and `dc`.`closed` = 1""")	