from sqlalchemy import *
from migrate import *
import migrate.changeset


def getTable(meta):
    return Table('carditem', meta, autoload=True)


def getColumns():
    return [Column('multiplicator', Numeric(precision=15, scale=2), nullable=True),
            Column('multiplicatorbeg', Date, nullable=True),
            Column('multiplicatorend', Date, nullable=True),
            Column('multiplicatorcurrent', Numeric(precision=15, scale=2), nullable=True)
            ]


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    for col in getColumns():
        if not col.name in getTable(meta).columns:
            col.create(getTable(meta))


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    if "multiplicator" in getTable(meta).columns:
        getTable(meta).c.multiplicator.drop()
    if "multiplicatorbeg" in getTable(meta).columns:
        getTable(meta).c.multiplicatorbeg.drop()
    if "multiplicatorend" in getTable(meta).columns:
        getTable(meta).c.multiplicatorend.drop()
    if "multiplicatorcurrent" in getTable(meta).columns:
        getTable(meta).c.multiplicatorcurrent.drop()
