from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getWorkshiftIndexOld(meta):
    workshift = Table('workshift', meta, autoload=True)
    return Index('workshiftunique', workshift.c.shiftnum, workshift.c.cashcode, workshift.c.shifttype, unique=True)

def getWorkshiftIndexNew(meta):
    workshift = Table('workshift', meta, autoload=True)
    return Index('workshiftunique', workshift.c.shiftnum, workshift.c.cashcode, workshift.c.shifttype, workshift.c.shopcode, unique=True)

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)
    # Upgrade operations go here. Don't create your own engine; bind
    # migrate_engine to your metadata
    getWorkshiftIndexOld(meta).drop()
    getWorkshiftIndexNew(meta).create()
    


def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    getWorkshiftIndexNew(meta).drop()
    getWorkshiftIndexOld(meta).create()
