from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTable(meta):
    return Table('document', meta, autoload=True)

def getIndex(meta):
    document = getTable(meta)
    return Index('documentIdentifier', document.c.identifier, unique=False)

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind
    # migrate_engine to your metadata
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    identifier=Column('identifier', String(30), nullable=True)
    if 'identifier' not in getTable(meta).columns: 
        identifier.create(getTable(meta))
    if 'documentIdentifier' not in [ind.name for ind in getTable(meta).indexes]:
        getIndex(meta).create()



def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind=migrate_engine)
    if 'documentIdentifier' in [ind.name for ind in getTable(meta).indexes]:
        getIndex(meta).drop() 
    if 'identifier' in getTable(meta).columns:
        getTable(meta).c.identifier.drop()
