from sqlalchemy import *
from migrate import *
from documents.versions import dump


def getTable(meta):
    return Table('document', meta, autoload=True)


def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    column = Column('actorcode', String(30), nullable=True)
    if column.name not in getTable(meta).columns:
        column.create(getTable(meta))


def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind=migrate_engine)
    if 'actorcode' in getTable(meta).columns:
        getTable(meta).c.actorcode.drop()
