from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTable(meta):
    return Table('document', meta, autoload=True)

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)
    document = getTable(meta)
    nopdfUrlEgais=Column('nopdfUrlEgais', Text, nullable=True)
    nopdfDigitalSignatureEgais=Column('nopdfDigitalSignatureEgais', Text, nullable=True)
    
    if 'nopdfUrlEgais' not in document.columns:
        nopdfUrlEgais.create(document)
    if 'nopdfDigitalSignatureEgais' not in document.columns:
        nopdfDigitalSignatureEgais.create(document)

def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    
    document = getTable(meta)
    if 'nopdfUrlEgais' in document.columns:
        document.c.nopdfUrlEgais.drop()
    if 'nopdfDigitalSignatureEgais' in document.columns:
        document.c.nopdfDigitalSignatureEgais.drop()
