from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTables(meta):
    return Table('goodsitem', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    tbl = getTables(meta)
    if not 'alcocode' in tbl.columns:
        Column('alcocode', String(20), nullable=True).create(tbl)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if 'alcocode' in tbl.columns:
        Column('alcocode', String(20), nullable=True).drop(tbl)
