from sqlalchemy import *
from migrate import *


def getDocument(meta):
    return Table('document', meta, autoload=True)

def getGoodsitem(meta):
    return Table('goodsitem', meta, autoload=True)

def getGiftTable(meta):
    return Table('gift', meta,
        Column('giftid', Integer, nullable = False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey(getDocument(meta).c.documentid, name='giftdocumentidfk',
                ondelete='CASCADE'), nullable = False),
        Column('goodsitemid', Integer, ForeignKey(getGoodsitem(meta).c.goodsitemid, name='giftgoodsitemidfk',
                ondelete='SET NULL'), nullable = True),
        Column('bcode', String(100), nullable = False),
        Column('name', String(200), nullable = False),
        Column('isfiscal', Boolean, nullable = False),
        mysql_engine='InnoDB'
    )

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    giftTable = getGiftTable(meta)
    if not giftTable.exists(meta.bind):
        giftTable.create()


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    giftTable = getGiftTable(meta)
    if giftTable.exists(meta.bind):
        giftTable.drop()
