# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *
import migrate.changeset

idxName = 'operationididx'

def getTable(meta):
    return Table('draftbeeritem', meta, autoload=True)

def getIndex(meta):
    return Index(idxName, getTable(meta).c.operationid, unique=True)


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTable(meta)

    if idxName not in [ind.name for ind in tbl.indexes]:
        getIndex(meta).create()

    tbl.c.name.alter(nullable=True)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTable(meta)

    if idxName in [ind.name for ind in tbl.indexes]:
        getIndex(meta).drop()

    tbl.c.name.alter(nullable=False)
